var util = require('../../../utils/util.js');
var api = require('../../../config/api.js');

var app = getApp();

Page({
  data: {
    couponList: [],
    code: '', 
    status: 0,
    page: 1,
    limit: 20,
    count: 0,
    scrollTop: 0,
    showPage: false,
    currentType: 0, 
    totalList: []
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    if (app.globalData.hasLogin) {
      this.getCouponList(false);
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },


  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },
  goCouponList(e){ 
    let id = e.currentTarget.dataset.id; 
    if (!app.globalData.hasLogin) {
      wx.navigateTo({
        url: "/pages/auth/login/login",
      })
      return;
    }

    wx.navigateTo({
      url: '/pages/ucenter/couponList/couponList',
    })
  },
  goService(e) { 
    let id = e.currentTarget.dataset.id; 
    
    if (!app.globalData.hasLogin) {
      wx.navigateTo({
        url: "/pages/auth/login/login",
      })
      return;
    }

    wx.navigateTo({
      url: '/pages/ucenter/couponList/couponList?type=1&coupon='+id,
    })
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {
    wx.showNavigationBarLoading() //在标题栏中显示加载
    this.getCouponList();
    wx.hideNavigationBarLoading() //完成停止加载
    wx.stopPullDownRefresh() //停止下拉刷新
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  getCouponList: function (hasMobile) {
    if (hasMobile!=false&&this.data.code.length != 11) {
      util.showErrorToast("请输入正确手机号");
      return;
    }
    let that = this;
    that.setData({
      scrollTop: 0,
      showPage: false,
      couponList: []
    });
    util.request(api.CouponPre, {
      mobile: that.data.code 
    }).then(function (res) {
      if (res.errno === 0) { 
        that.setData({
          scrollTop: 0,
          couponList: res.data
        });
        wx.showToast({
          title: "查询成功",
          duration: 2000
        }) 
      }
    });

  },
  bindExchange: function (e) {
    this.setData({
      code: e.detail.value
    });
  },
  clearExchange: function () {
    this.setData({
      code: ''
    });
  },  
  nextPage: function (event) {
    var that = this;
    if (this.data.page > that.data.count / that.data.limit) {
      return true;
    }

    that.setData({
      page: that.data.page + 1,
      currentType: 0
    });

    this.getCouponList();

  },
  prevPage: function (event) {
    if (this.data.page <= 1) {
      return false;
    }

    var that = this;
    that.setData({
      page: that.data.page - 1,
      currentType: 0
    });
    this.getCouponList();
  },  

})